OpenTTD Source: ManyOfManySettingDesc Struct Reference

OpenTTD Source 15.0-beta1

Public Member Functions
ManyOfManySettingDesc Struct Reference

Many of many setting. More...

`#include <settings_internal.h>`

Inheritance diagram for ManyOfManySettingDesc:

## Public Member Functions
| ManyOfManySettingDesc (const SaveLoad &save, SettingFlag flags, bool startup, int32_t def, StringID str, StringID str_help, StringID str_val, SettingCategory cat, PreChangeCheck pre_check, PostChangeCallback post_callback, GetTitleCallback get_title_cb, GetHelpCallback get_help_cb, SetValueDParamsCallback set_value_dparams_cb, GetDefaultValueCallback get_def_cb, std::initializer_list< const char * > many, OnConvert *many_cnvt)
size_t | ParseValue (const char *str) const override
| Convert a string representation (external) of an integer-like setting to an integer.
std::string | FormatValue (const void *object) const override
| Format the value of the setting associated with this object.
Public Member Functions inherited from OneOfManySettingDesc
| OneOfManySettingDesc (const SaveLoad &save, SettingFlag flags, bool startup, int32_t def, int32_t max, StringID str, StringID str_help, StringID str_val, SettingCategory cat, PreChangeCheck pre_check, PostChangeCallback post_callback, GetTitleCallback get_title_cb, GetHelpCallback get_help_cb, SetValueDParamsCallback set_value_dparams_cb, GetDefaultValueCallback get_def_cb, std::initializer_list< const char * > many, OnConvert *many_cnvt)
std::string | FormatSingleValue (uint id) const
size_t | ParseValue (const char *str) const override
| Convert a string representation (external) of an integer-like setting to an integer.
std::string | FormatValue (const void *object) const override
| Format the value of the setting associated with this object.
Public Member Functions inherited from IntSettingDesc
template<typename Tdef , typename Tmin , typename Tmax , typename Tinterval , std::enable_if_t< std::disjunction_v< std::is_convertible< Tdef, int32_t >, std::is_base_of< StrongTypedefBase, Tdef > >, int > = 0, std::enable_if_t< std::disjunction_v< std::is_convertible< Tmin, int32_t >, std::is_base_of< StrongTypedefBase, Tmin > >, int > = 0, std::enable_if_t< std::disjunction_v< std::is_convertible< Tmax, uint32_t >, std::is_base_of< StrongTypedefBase, Tmax > >, int > = 0, std::enable_if_t< std::disjunction_v< std::is_convertible< Tinterval, int32_t >, std::is_base_of< StrongTypedefBase, Tinterval > >, int > = 0>
| IntSettingDesc (const SaveLoad &save, SettingFlag flags, bool startup, Tdef def, Tmin min, Tmax max, Tinterval interval, StringID str, StringID str_help, StringID str_val, SettingCategory cat, PreChangeCheck pre_check, PostChangeCallback post_callback, GetTitleCallback get_title_cb, GetHelpCallback get_help_cb, SetValueDParamsCallback set_value_dparams_cb, GetDefaultValueCallback get_def_cb)
StringID | GetTitle () const
| Get the title of the setting.
StringID | GetHelp () const
| Get the help text of the setting.
void | SetValueDParams (uint first_param, int32_t value) const
| Set the DParams for drawing the value of the setting.
virtual bool | IsBoolSetting () const
| Check whether this setting is a boolean type setting.
bool | IsIntSetting () const override
| Check whether this setting is an integer type setting.
void | ChangeValue (const void *object, int32_t newvalue) const
| Handle changing a value.
void | MakeValueValidAndWrite (const void *object, int32_t value) const
| Make the value valid and then write it to the setting.
void | ParseValue (const IniItem *item, void *object) const override
| Parse/read the value from the Ini item into the setting associated with this object.
bool | IsSameValue (const IniItem *item, void *object) const override
| Check whether the value in the Ini item is the same as is saved in this setting in the object.
bool | IsDefaultValue (void *object) const override
| Check whether the value is the same as the default value.
void | ResetToDefault (void *object) const override
| Reset the setting to its default value.
int32_t | Read (const void *object) const
| Read the integer from the the actual setting.
Public Member Functions inherited from SettingDesc
| SettingDesc (const SaveLoad &save, SettingFlag flags, bool startup)
bool | IsEditable (bool do_command=false) const
| Check whether the setting is editable in the current gamemode.
SettingType | GetType () const
| Return the type of the setting.
constexpr const std::string & | GetName () const
| Get the name of this setting.
virtual bool | IsStringSetting () const
| Check whether this setting is an string type setting.
const struct IntSettingDesc * | AsIntSetting () const
| Get the setting description of this setting as an integer setting.
const struct StringSettingDesc * | AsStringSetting () const
| Get the setting description of this setting as a string setting.

## Additional Inherited Members
Public Types inherited from OneOfManySettingDesc
typedef size_t | OnConvert(const char *value)
| callback prototype for conversion error
Public Types inherited from IntSettingDesc
typedef StringID | GetTitleCallback(const IntSettingDesc &sd)
typedef StringID | GetHelpCallback(const IntSettingDesc &sd)
typedef void | SetValueDParamsCallback(const IntSettingDesc &sd, uint first_param, int32_t value)
typedef bool | PreChangeCheck(int32_t &value)
| A check to be performed before the setting gets changed.
typedef void | PostChangeCallback(int32_t value)
| A callback to denote that a setting has been changed.
typedef int32_t | GetDefaultValueCallback()
| A callback to get the correct default value.
Static Public Member Functions inherited from OneOfManySettingDesc
static size_t | ParseSingleValue (const char *str, size_t len, const std::vector< std::string > &many)
| Find the index value of a ONEofMANY type in a string separated by |.
Data Fields inherited from OneOfManySettingDesc
std::vector< std::string > | many
| possible values for this type
OnConvert * | many_cnvt
| callback procedure when loading value mechanism fails
Data Fields inherited from IntSettingDesc
int32_t | def
| default value given when none is present
int32_t | min
| minimum values
uint32_t | max
| maximum values
int32_t | interval
| the interval to use between settings in the 'settings' window. If interval is '0' the interval is dynamically determined
StringID | str
| (translated) string with descriptive text; gui and console
StringID | str_help
| (Translated) string with help text; gui only.
StringID | str_val
| (Translated) first string describing the value.
SettingCategory | cat
| assigned categories of the setting
PreChangeCheck * | pre_check
| Callback to check for the validity of the setting.
PostChangeCallback * | post_callback
| Callback when the setting has been changed.
GetTitleCallback * | get_title_cb
GetHelpCallback * | get_help_cb
SetValueDParamsCallback * | set_value_dparams_cb
GetDefaultValueCallback * | get_def_cb
| Callback to set the correct default value.
Data Fields inherited from SettingDesc
SettingFlag | flags
| Handles how a setting would show up in the GUI (text/currency, etc.).
bool | startup
| Setting has to be loaded directly at startup?.
SaveLoad | save
| Internal structure (going to savegame, parts to config).

## Detailed Description

Many of many setting.

Definition at line 304 of file settings_internal.h.

## Constructor & Destructor Documentation

## ◆ ManyOfManySettingDesc()

ManyOfManySettingDesc::ManyOfManySettingDesc | ( | const SaveLoad & | save,
|  | SettingFlag | flags,
|  | bool | startup,
|  | int32_t | def,
|  | StringID | str,
|  | StringID | str_help,
|  | StringID | str_val,
|  | SettingCategory | cat,
|  | PreChangeCheck | pre_check,
|  | PostChangeCallback | post_callback,
|  | GetTitleCallback | get_title_cb,
|  | GetHelpCallback | get_help_cb,
|  | SetValueDParamsCallback | set_value_dparams_cb,
|  | GetDefaultValueCallback | get_def_cb,
|  | std::initializer_list< const char * > | many,
|  | OnConvert * | many_cnvt
| ) |  |
| inline

Definition at line 305 of file settings_internal.h.

## Member Function Documentation

## ◆ FormatValue()

std::string ManyOfManySettingDesc::FormatValue | ( | const void * | object | ) | const
| overridevirtual

Format the value of the setting associated with this object.

Parameters

  buf | The before of the buffer to format into.
  last | The end of the buffer to format into.
  object | The object the setting is in.

Reimplemented from IntSettingDesc.

Definition at line 359 of file settings.cpp.

References IntSettingDesc::Read().

## ◆ ParseValue()

size_t ManyOfManySettingDesc::ParseValue | ( | const char * | str | ) | const
| overridevirtual

Convert a string representation (external) of an integer-like setting to an integer.

Parameters

  str | Input string that will be parsed based on the type of desc.

Returns
  The value from the parse string, or the default value of the setting.

Reimplemented from IntSettingDesc.

Definition at line 413 of file settings.cpp.

References _settings_error_list, IntSettingDesc::def, SettingDesc::GetName(), LookupManyOfMany(), OneOfManySettingDesc::many, ErrorMessageData::SetDParamStr(), and IntSettingDesc::str.

The documentation for this struct was generated from the following files:

- src/settings_internal.h
- src/settings.cpp